#include <os.h>
#include "charmap.h"
void setPixel(int x, int y, unsigned int color)
{
	static unsigned char *scr = (unsigned char *) SCREEN_BASE_ADDRESS;
	if(x >= 0 && x < SCREEN_WIDTH && y >= 0 && y < SCREEN_HEIGHT)
	{
		scr[y*SCREEN_WIDTH/2+x/2]=x&1? (scr[y*SCREEN_WIDTH/2+x/2]&0xF0)+color : (scr[y*SCREEN_WIDTH/2+x/2]&0x0F)+(color<< 4);
	}
}

void putChar(int x, int y, char ch, int bgColor, int textColor)
{
	int i, j, pixelOn;
	for(i = 0; i < CHAR_WIDTH; i++)
	{
		for(j = 0; j < CHAR_HEIGHT; j++)
		{
			pixelOn = charmap_5x8[(unsigned char)ch][i] << j ;
			pixelOn = pixelOn & 0x80 ;
			if (pixelOn)
			{
				setPixel(x+i,y+j,textColor);
			}
			else if(!pixelOn)
			{
				setPixel(x+i,y+j,bgColor);
			}
		}
	}
}
void putStr(int x, int y, char* str, int bgColor, int textColor)
{
	int l = strlen(str);
	int i;
	int stop=0;
	for (i = 0; i < l && !stop; i++)
	{
		if (str[i] == 0x0A)
		{
			putChar(x,y, ' ', bgColor, textColor);
			x += CHAR_WIDTH;
		}
		else
		{
			putChar(x, y, str[i], bgColor, textColor);
			x += CHAR_WIDTH;
		}
		if (x >= SCREEN_WIDTH-CHAR_WIDTH)
		{
			stop=1;
		}
	}
}
